#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/semaphore.h>
#include <linux/spinlock.h>
#include <linux/sched.h>
#include <linux/delay.h>
#include <linux/thread_info.h>
#include <linux/interrupt.h>
#include <linux/kthread.h>

MODULE_LICENSE("Dual BSD/GPL");

int func()
{
    for(;;) 
    {
       local_irq_disable();
       local_irq_enable();
    }
    return 0;  
}

static int hello_init(void)
{
    printk(KERN_EMERG "hello,kernel\n");
    struct task_struct * ts = current;

    kthread_run(func,NULL,"Int Disable");
    printk("pid = %d\n",ts->pid);

    printk(KERN_EMERG "### unlock 1\n");
    return 0;
}

static void hello_exit(void)
{
    printk(KERN_EMERG "goodbye,kernel\n");
}

module_init(hello_init);
module_exit(hello_exit);

MODULE_AUTHOR("Shen Yang");
