#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/semaphore.h>
#include <linux/spinlock.h>
#include <linux/sched.h>
#include <linux/delay.h>
#include <linux/thread_info.h>

MODULE_LICENSE("Dual BSD/GPL");
DEFINE_SPINLOCK(lock);

static int hello_init(void)
{
    printk(KERN_EMERG "hello,kernel\n");
    struct task_struct * ts = current;
    printk("pid = %d\n",ts->pid);

    spin_lock(&lock);
    printk(KERN_EMERG "### lock 1\n");

    int i;
    for (i = 1; i <= 2; ++i) { printk("%d\n",i); i = i*i; i = i/i;}

    spin_unlock(&lock);
    printk(KERN_EMERG "### unlock 1\n");
    return 0;
}

static void hello_exit(void)
{
    printk(KERN_EMERG "goodbye,kernel\n");
}

module_init(hello_init);
module_exit(hello_exit);

MODULE_AUTHOR("Shen Yang");
