#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <stddef.h>
#include <dirent.h>

#define err_sys(info)     \
        {                 \
	       fprintf(stderr,"%s:%d\n",info,strerror(errno));          \
               exit(EXIT_FAILURE);    \
	}

int main()
{
	int fd[2];
	pid_t pid;
        char line[50];
	int n , i;

	if(pipe(fd) < 0)
	{
		err_sys("pipe error");
	}
	else
	{
		if((pid = fork()) < 0)
		{
			err_sys("fork error");
		}
		else if (pid > 0)
		{
			close(fd[0]);
			for(;;)
				{printf("pid = %d\n",getpid()); write(fd[1],"hi\n",3); sleep(3); break;}
			exit(1);
		}
		else
		{
			close(fd[1]);
			for(;;)
			{
				n = read(fd[0],line,10);
				for(i=0;i<n;i++)
					{printf("pid = %d , %c\n",getpid(),line[i]); sleep(2);}
			}
		}
	}
}
