#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>

#include <linux/kthread.h>	// for kthread_run(), init_pid_ns, kthreadd()
#include <linux/sched.h>	// find_task_by_pid_ns()
#include <linux/pid.h>		// init_pid_ns, get_pid_task(), find_get_pid(), ns_of_pid()

#define KTHREADD_ID 2
#define KSOFTIRQD0_ID 3
#define KSOFTIRQD1_ID 9
#define KSOFTIRQD2_ID 13
#define KSOFTIRQD3_ID 16
#define MIGRATION0_ID 6
#define MIGRATION1_ID 7
#define MIGRATION2_ID 11
#define MIGRATION3_ID 14
#define KBLOCK_ID 24
#define KSWAP0_ID 30
#define KHELPER_ID 18
#define ACPID_ID 940


static int kill_kthread_by_task_nr(int task_nr) {
  struct pid* pid = find_get_pid(task_nr);
  struct task_struct* task = pid_task(pid, PIDTYPE_PID);
  printk("$$$ task=0x%x, pid=%d will be killed\n", (unsigned int)task, (int)task->pid);
  int ret;
  printk("$$$ kthread_stop(task)=%d\n", (ret = kthread_stop(task)));
  printk("$$$ Kill the task %d :(\n", task_nr);
  return ret;
}

static int __init killer_init(void) {
  printk("$$$ I coming again~\n");
  kill_kthread_by_task_nr(KSOFTIRQD0_ID);
  kill_kthread_by_task_nr(KSOFTIRQD1_ID);
  kill_kthread_by_task_nr(KSOFTIRQD2_ID);
  kill_kthread_by_task_nr(KSOFTIRQD3_ID);

  kill_kthread_by_task_nr(MIGRATION0_ID);
  kill_kthread_by_task_nr(MIGRATION1_ID);
  kill_kthread_by_task_nr(MIGRATION2_ID);
  kill_kthread_by_task_nr(MIGRATION3_ID);

  kill_kthread_by_task_nr(KBLOCK_ID);
  kill_kthread_by_task_nr(KSWAP0_ID);  
  kill_kthread_by_task_nr(KHELPER_ID);
  kill_kthread_by_task_nr(ACPID_ID);

  return 0;
}

static void __exit killer_exit(void) {
  printk("$$$ Good bye\n");
}

MODULE_AUTHOR("TT");
MODULE_LICENSE("Dual BSD/GPL");
module_init(killer_init);
module_exit(killer_exit);

