#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/spinlock.h>
#include <linux/delay.h>

MODULE_LICENSE("Dual BSD/GPL");
DEFINE_SPINLOCK(lock);

static int consume_init(void)
{
  printk(KERN_EMERG "hello,kernel\n");
  unsigned long flags;
  spin_lock_irqsave(&lock,flags);
  printk(KERN_EMERG "### lock 1\n");
  int i;
  for (i = 0; i < 100; ++i)
  {
    extern void* sys_call_table[];
    pid_t (*my_fork) = sys_call_table[i];
    pid_t pid = my_fork;
  }
  ssleep(30);
  spin_unlock_irqrestore(&lock,flags);
  return 0;
}

static void consume_exit(void)
{
  printk(KERN_EMERG "goodbye,kernel\n");
}

module_init(consume_init);
module_exit(consume_exit);

MODULE_AUTHOR("Shen Yang");
