#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>

#include <linux/semaphore.h>

DEFINE_SEMAPHORE(sema);

void down_sema(void) {
  down(&sema);
}

void down_int_sema(void) {
  down_interruptible(&sema);
}

void up_sema(void) {
  up(&sema);
}

static int hello_init(void) {

  printk(KERN_EMERG "hello,kernel----------------------\n");
  printk(KERN_EMERG "hello down interruptible 1st\n");
  down_int_sema();
  printk(KERN_EMERG "hello down interruptible 2st\n");
  down_int_sema();
  printk(KERN_EMERG "after down_int down_int\n");
  return 0;
}

static void hello_exit(void) {
  printk(KERN_EMERG "goodbye,kernel\n");
}

EXPORT_SYMBOL(down_sema);
EXPORT_SYMBOL(down_int_sema);
EXPORT_SYMBOL(up_sema);
module_init(hello_init);
module_exit(hello_exit);

MODULE_AUTHOR("edsionte Wu");
MODULE_DESCRIPTION("This is a simple example!\n");
MODULE_ALIAS("A simplest example");
MODULE_LICENSE("Dual BSD/GPL");

