/* --TT
 * This file only define one funtion alert(), which trigger the Detector and
 * send information to Detector.
 * alert should be invoked only Monitor consider the hang failure may occur.
 */

#include "include/alert.h"

#define FLOAT_TO_INT(x)	(int)(x)

static int sockfd;
static struct det_msg dm;

int init_alert() {
  sockfd = socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
  if(sockfd == -1) {
    perror("can not create a socket\n");
    return -1;
  }
  return 0;
}

void close_alert() {
  close(sockfd);
}

static void fill_msg(unsigned int cmd, unsigned int code) {
  dm.error_code = code;
  if ((dm.cmd = cmd) == DET_WAKEUP)
    return;
  int i;
  for (i = 0; i < CPU_NR; ++i) {
    dm.c[i].sys = FLOAT_TO_INT(ci[i].sys);
    dm.c[i].iowait = FLOAT_TO_INT(ci[i].iowait);
    dm.c[i].usr = FLOAT_TO_INT(ci[i].usr);
  }
  dm.run_proc_num = pi.run_proc_num;
  dm.blk_proc_num = pi.blk_proc_num;
  dm.kbmemfree = mi.kbmemfree;
  dm.util = FLOAT_TO_INT(ioi.di[0].util);
}

/*
 * Trigger Detector and send information to kernel space.
 */
void alert(unsigned int code) {
  fill_msg(DET_ALERT, code);
  setsockopt(sockfd, IPPROTO_IP, SOCKET_OPS_SET, &dm, sizeof(struct det_msg)); 
}

/*
 * Wake up the detector to notify that monitor, is still alive~
 */
void wakeup_detector() {
  fill_msg(DET_WAKEUP, 0);
  setsockopt(sockfd, IPPROTO_IP, SOCKET_OPS_SET, &dm, sizeof(struct det_msg)); 
}

